Subject: bug#22248: gnus-article-mode omits apostrophe from isearch string

From: Juri Linkov <[email-masked]>
Date: Sun, 27 Dec 2015 02:28:05 +0200

Trying to put an expression like (setq var 'foo) into the isearch ring
by moving point at its beginning and typing C-s C-w C-w C-w ...
doesn't add apostrophe in Gnus because gnus-article-mode modifies
syntax of ' to whitespace:

  (defvar gnus-article-mode-syntax-table
    (let ((table (copy-syntax-table text-mode-syntax-table)))
      ;; make M-. in article buffers work for `foo' strings
      (modify-syntax-entry ?' " " table)
      (modify-syntax-entry ?` " " table)

and lax-whitespace search together with isearch-yank-word-or-char
squeeze apostrophe in a sequence of space characters.

One solution is to modify syntax of ' and ` in gnus-article-mode-syntax-table
to syntax discussed in bug#22238, i.e. not whitespace and not part
of a symbol, still allowing M-. in article buffers work for `foo' strings,
and allowing isearch to search in other buffers the same string yanked
to the search ring from Gnus.